#include "Ji330c2Obj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJi330c2Obj = Ji330c2Obj().Register();


void Ji330c2Obj::writeContent(JOutputStream& os) {
  JAddObj::writeContent(os);
  putObject(os, "delimiter", delimiter);
  putObject(os, "protocol", protocol);
}

void Ji330c2Obj::readContent(JDictionary& dict) {
  JAddObj::readContent(dict);
  JObject* obj_delimiter = getObject( dict, "delimiter");
  if ( obj_delimiter ) delimiter = *(JString*)obj_delimiter;
  JObject* obj_protocol = getObject( dict, "protocol");
  if ( obj_protocol ) protocol = *(JString*)obj_protocol;
  theProtocol = new StrProtocol();
  theProtocol->loadProtocol( (char*)protocol );
}

const char* Ji330c2Obj::className() const { return "Ji330c2Obj";}


JObject* Ji330c2Obj::clone() const { return new Ji330c2Obj(*this);}


// class constructor
Ji330c2Obj::Ji330c2Obj() {
  igm = 1 + 1;
  ogm = 8 + 1 + 1 + 1 + 1;
  data = 0;
  enabled = 0;
}

int Ji330c2Obj::inputType( int n ) {
	if ( n == 0 ) {
		return( JBytesData::id );
	} else {
		return( JIntegerData::id );
	}
}

void Ji330c2Obj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("i330c2"), rect);
}


boolean Ji330c2Obj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString Ji330c2Obj::inputTag(int n) {
  char* tag[] = {
    "data",
    "enabled" };
  return( tag[n] );
}


JString Ji330c2Obj::outputTag(int n) {
  char* tag[] = {
    "protocolOut",
    "section",
    "step",
    "lastIntIn" };
	char* valTag[] = {
		"value 0",
			"value 1",
			"value 2",
			"value 3",
			"value 4",
			"value 5",
			"value 6",
			"value 7" };
	if ( n < 8 ) {
		return( valTag[n] );
	} else {
  return( tag[n- 8] );
	}
}


JFRect Ji330c2Obj::inputArea(int n) {
  if ( n < ( 1 )) {
    return leftArea( n, 0, 1, 0.1, 0.8 );
  } else {
    return topArea( n, 1, 1, 0.25 );
  }
}


JFRect Ji330c2Obj::outputArea(int n) {
  if ( n < 8 ) {
    return rightArea(n, 0, 8);
  } else {
    return bottomArea(n, 8, 4);
  }
}


int Ji330c2Obj::inputFace(int n) {
  if ( n < 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int Ji330c2Obj::outputFace(int n) {
  if ( n < 8 ) {
    return RIGHT;
  } else {
    return BOTTOM;
  }
}


JFPoint Ji330c2Obj::inputPoint(int n, JLinkObj& link) {
  if (n<1) return leftPoint(n, link, 0, 1, 0.1, 0.8);
  return topPoint(n, link, 1, 1);
}


JFPoint Ji330c2Obj::outputPoint(int n, JLinkObj& link) {
  if ( n < 8 ) {
    return rightPoint(n, link, 0, 8);
  } else {
    return bottomPoint(n, link, 8, 4);
  }
}


void Ji330c2Obj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n < 8 ) {
     INT(data) = values[n];
  } else if ( n == PROTOCOL_OUT ) {
     INT(data) = protocolOut;
  } else if ( n == SECTION ) {
	  INT(data) = section;
  } else if ( n == STEP ) {
	  INT( data ) = step;
  } else {
	  INT(data ) = lastIntIn;
  }
}

#include <malloc.h>
#include <stdio.h>
#include <string.h>
char* debugStr( char* s, int val ) {
	char buf[200];
	sprintf( buf, "%s %d", s, val );
	char* ss = (char*)malloc( strlen( buf ) + 1 );
	strcpy( ss, buf );
	return( ss );
}

void Ji330c2Obj::processByte(int b) {
	lastIntIn = b;
	broadcast( LAST_VALUE );
	JComponent::debug( debugStr( "in val: ", lastIntIn ));
	if ( theProtocol->getNextIntToReceive() == -1 ) {
		runStep();
	}
}

void Ji330c2Obj::engine(int n, JLinkObj& link) {
  switch (n) {
  case DATA: {
	    JBlock data;
  link.access(JBlockData(data));
  int size = data.size();
  data.Dereference();
  for (int i=0; i<size; i++)
    processByte((uchar)data[i]);
			 }
    break;
  case ENABLED:
    link.access(JIntegerData(enabled));
	if ( enabled ) {
		runStep();
	}
    break;
  default:
    break;
  }
}



void Ji330c2Obj::runStep() {
	JComponent::debug( "...starting step..." );
	if ( theProtocol->hasMoreSteps() ) {
		step = theProtocol->getStepNumber();
		JComponent::debug( debugStr( "Step: ", step ));
		broadcast( STEP );
		int val = theProtocol->getNextIntToSend();
		while ( val != -1 ) {
			protocolOut = val;
			JComponent::debug( debugStr( "val: ", val ));
			broadcast( PROTOCOL_OUT );
			val= theProtocol->getNextIntToSend();
		}
	}
	JComponent::debug( "...finished with step..." );
}

JArray Ji330c2Obj::getProperties() {
  JArray properties;
  properties.append(JStringProperty("delimiter", delimiter));
  properties.append(JStringProperty("protocol", protocol));
  return properties;
}


boolean Ji330c2Obj::updateProperty(JProperty& prop) {
  if (prop.getName() == JString("delimiter")) {
    delimiter = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("protocol")) {
    protocol = ((JStringProperty*)&prop)->value;
	theProtocol->init();
	theProtocol->loadProtocol( (char*)protocol );
    return true;
  }
  return false;
}


