class Step {
public:
	Step(unsigned char* inValues, int inLength, unsigned char* outValues, int outLength );
	void startUp();
	int getNextInValue();
	int getNextOutValue();
	bool checkReceivedInt( unsigned char val );
private:
	unsigned char* inValues;
	int inLength;
	int currentInOffset;
	unsigned char* outValues;
	int outLength;
	int currentOutOffset;
};

#define STEPCOUNT 100

class StrProtocol {
public:
	StrProtocol();
	void setString( char* str );
	void startUp();
	int getNextIntToSend();
	int getNextIntToReceive();
	int getStepNumber();
	bool checkReceivedInt( int val );
	int getLastIntReceived();
	bool hasMoreSteps();
	void loadProtocol( char* fileName );
	void init();
private:
	void addStep( unsigned char* inValues, int inLen, unsigned char* outValues, int outLen );

	Step* steps[STEPCOUNT];
	int lastStep;
	int currentStep;
};