#include "JStringSwitchObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"
#include <string.h>


char* theJStringSwitchObj = JStringSwitchObj().Register();


void JStringSwitchObj::writeContent(JOutputStream& os) {
  JAddObj::writeContent(os);
  putObject(os, "s1", s1);
  putObject(os, "s2", s2);
  putObject(os, "s3", s3);
  putObject(os, "s4", s4);
  putObject(os, "s5", s5);
  putObject(os, "s6", s6);
  putObject(os, "s7", s7);
  putObject(os, "s8", s8);
  putObject(os, "s9", s9);
  putObject(os, "s10", s10);
}

void JStringSwitchObj::readContent(JDictionary& dict) {
  JAddObj::readContent(dict);
  JObject* obj_s1 = getObject( dict, "s1");
  if ( obj_s1 ) s1 = *(JString*)obj_s1;
  JObject* obj_s2 = getObject( dict, "s2");
  if ( obj_s2 ) s2 = *(JString*)obj_s2;
  JObject* obj_s3 = getObject( dict, "s3");
  if ( obj_s3 ) s3 = *(JString*)obj_s3;
  JObject* obj_s4 = getObject( dict, "s4");
  if ( obj_s4 ) s4 = *(JString*)obj_s4;
  JObject* obj_s5 = getObject( dict, "s5");
  if ( obj_s5 ) s5 = *(JString*)obj_s5;
  JObject* obj_s6 = getObject( dict, "s6");
  if ( obj_s6 ) s6 = *(JString*)obj_s6;
  JObject* obj_s7 = getObject( dict, "s7");
  if ( obj_s7 ) s7 = *(JString*)obj_s7;
  JObject* obj_s8 = getObject( dict, "s8");
  if ( obj_s8 ) s8 = *(JString*)obj_s8;
  JObject* obj_s9 = getObject( dict, "s9");
  if ( obj_s9 ) s9 = *(JString*)obj_s9;
  JObject* obj_s10 = getObject( dict, "s10");
  if ( obj_s10 ) s10 = *(JString*)obj_s10;
}

const char* JStringSwitchObj::className() const { return "JStringSwitchObj";}


JObject* JStringSwitchObj::clone() const { return new JStringSwitchObj(*this);}


// class constructor
JStringSwitchObj::JStringSwitchObj() {
  igm = 1;
  ogm = 1;
  whichString = 0;
}


void JStringSwitchObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, result, rect);
}


boolean JStringSwitchObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JStringSwitchObj::inputTag(int n) {
  char* tag[] = {
    "whichString" };
  return( tag[n] );
}


int JStringSwitchObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JStringSwitchObj::outputTag(int n) {
  char* tag[] = {
    "result" };
  return( tag[n] );
}


JFRect JStringSwitchObj::inputArea(int n) {
  //if ( n < ( 1 )) {
    return leftArea( n, 0, 1, 0.1, 0.8 );
  //}
}


JFRect JStringSwitchObj::outputArea(int n) {
  return rightArea(n, 0, 1);
}


int JStringSwitchObj::inputFace(int n) {
  if ( n < 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JStringSwitchObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JStringSwitchObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1, 0.1, 0.8);
}


JFPoint JStringSwitchObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1);
}


void JStringSwitchObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = result;
  }
}


void JStringSwitchObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case WHICHSTRING:
    link.access(JIntegerData(whichString));
    break;
  default:
    break;
  }
  char* stringOut[10];
  int numberStrings = 0;
  char* stringIn[10] = { s1, s2, s3, s4, s5, s6, s7, s8, s9, s10 };
  for ( int i = 0; i < 10; i++ ) {
	  if ( strlen( stringIn[i] ) > 0 ) {
		  stringOut[ numberStrings++ ] = stringIn[i];
	  }
  }

  if ( numberStrings > 0 ) {
	int baseunit = 65535/numberStrings;
	int actualUnit = whichString/baseunit;
	if ( actualUnit < 0 ) {
		actualUnit = 0;
	} else if ( actualUnit >= numberStrings ) {
		actualUnit = 0;
	}
	result = stringOut[ actualUnit ];
	broadcast( 0 );
  }
}


JArray JStringSwitchObj::getProperties() {
  JArray properties;
  properties.append(JStringProperty("s1", s1));
  properties.append(JStringProperty("s2", s2));
  properties.append(JStringProperty("s3", s3));
  properties.append(JStringProperty("s4", s4));
  properties.append(JStringProperty("s5", s5));
  properties.append(JStringProperty("s6", s6));
  properties.append(JStringProperty("s7", s7));
  properties.append(JStringProperty("s8", s8));
  properties.append(JStringProperty("s9", s9));
  properties.append(JStringProperty("s10", s10));
  return properties;
}


boolean JStringSwitchObj::updateProperty(JProperty& prop) {
  if (prop.getName() == JString("s1")) {
    s1 = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("s2")) {
    s2 = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("s3")) {
    s3 = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("s4")) {
    s4 = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("s5")) {
    s5 = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("s6")) {
    s6 = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("s7")) {
    s7 = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("s8")) {
    s8 = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("s9")) {
    s9 = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("s10")) {
    s10 = ((JStringProperty*)&prop)->value;
    return true;
  }
  return false;
}


