#if !defined( _JStrSplitObj_h )
#define _JStrSplitObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"





class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JStrSplitObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      TEXT,
      ENABLED,
      RESET };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JStrSplitObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual int inputType( int n );
    virtual int outputType( int n );
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
  private:

	  void processText( char* text );
	  void broadcastText( char* text );
	  bool broadcasting;
	  char saveBuffer[100];

    // inputs
    JString text;

    // controls
    int enabled;
    int reset;

    // properties
    JString startStr;
    unsigned int segmentLength;

    // outputs
    JString string_segment;
};


#endif
